一个关于CAD文件属性读取的例子,在vs2010中测试通过。using System; using AutoCAD=Autodesk.AutoCAD.Interop; using System.Runtime.InteropServices ; using dbx = Autodesk.AutoCAD.Interop.Common; namespace SmartSoft.ACAD { /// /// 读取AutoCAD属性信息 /// public class AutoCADConnector:IDisposable { private AutoCAD.AcadApplication _Application; private bool _Initialized; private bool _Disposed; #region 类初始化及析构操作 /// /// 类初始化,试图获取一个正在运行的AutoCAD实例, /// 如果没有则新起动一个实例。 /// public AutoCADConnector() { try { //取得一个正在运行的AUTOCAD实例 this._Application = (AutoCAD.AcadApplication)Marshal.GetActiveObject("AutoCAD.Application.17"); }//end of try catch { try { //建立一个新的AUTOCAD实例,并标识已经建立成功。 _Application = new AutoCAD.AcadApplicationClass(); _Initialized=true; } catch { throw new Exception ("无法起动AutoCAD应用程序,确认已经安装"); } }//end of catch }//end of AutoCADConnector ~AutoCADConnector() { Dispose(false); } public void Dispose() { Dispose(true); GC.SuppressFinalize(this); } protected virtual void Dispose(bool disposing) { if (!this._Disposed && this._Initialized ) { //如果建立了AUTOCAD的实列,调用QUIT方法以避免内存漏洞 this._Application.ActiveDocument.Close (false,""); this._Application.Quit(); this._Disposed=true; } } #endregion #region 公共用户接口属性 /// /// 取得当前类所获得的AUTOCAD实例 /// public AutoCAD.AcadApplication Application { get { return _Application; } }//end of Application #endregion #region 公共用户接口方法 /// /// 根据给定的文件名以AxDbDocument类型返回该文档 /// public dbx.AxDbDocument GetThisDrawing(string FileName,string PassWord) { ACAD.AutoCADConnector Connector=new AutoCADConnector(); //这是AutoCAD2004的Programe ID string programeID ="ObjectDBX.AxDbDocument.17"; AutoCAD.AcadApplication AcadApp = Connector.Application; dbx.AxDbDocument dbxDoc; dbxDoc=(dbx.AxDbDocument)AcadApp.GetInterfaceObject(programeID); try { if (System.IO.File.Exists (FileName)==false) throw new Exception ("文件不存在。"); dbxDoc.Open(FileName,PassWord); }// end of try catch (Exception e) { System.Windows.Forms.MessageBox.Show(e.Message ); dbxDoc=null; } return dbxDoc; }//end of function GetThisDrawing /// /// 根据当前文档和块名取得当前块的引用 /// public dbx.AcadBlockReference GetBlockReference(dbx.AxDbDocument thisDrawing,string blkName) { dbx.AcadBlockReference blkRef=null; bool found = false; try { foreach (dbx.AcadEntity entity in thisDrawing.ModelSpace ) { if (entity.EntityName=="AcDbBlockReference") { blkRef=(dbx.AcadBlockReference)entity; //System.Windows.Forms.MessageBox.Show(blkRef.Name); if (blkRef.Name.ToLower() ==blkName.ToLower() ) { found = true; break; } }//end of entity.EntityName=="AcDbBlockReference" }// end of foreach thisDrawing.ModelSpace }//end of try catch (Exception e) { System.Windows.Forms.MessageBox.Show ("图形中有未知的错误,格式不正确或图形数据库需要修愎。系统错误提示:" e.Message ,"信息",System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Warning); thisDrawing=null; }//end of catch if (!found) blkRef = null; return blkRef; }//end of function GetBlockReference /// /// 根据给定的块引用(dbx.AcadBlockReference)和属性名返回属性值 /// public object GetValueByAttributeName(dbx.AcadBlockReference blkRef,string AttributeName) { object[] Atts=(object[])blkRef.GetAttributes(); object attValue=null; for (int i=0;i<Atts.Length;i ) { dbx.AcadAttributeReference attRef; attRef=(dbx.AcadAttributeReference)Atts[i]; if (attRef.TagString==AttributeName) { attValue= attRef.TextString ; break; } }//end of for i return attValue; }// end of function #endregion }//end of class CAutoCADConnector }//end of namespace AutoCAD
下载CAD属性读取vs2010通过用户还喜欢
- 18480 文章数
- 500万+ 热度
作者专栏
编辑推荐
- 淡抹u2引擎,修复内容较多,物有所值
- 界域传说·经典巨作=传世单机(一键安装)
- 丸子版本(175个传世版本大集合)
- GS版本:神话公益服务端+客户端
- 图片放大工具(放大图片不模糊)
- 剪映无限制VIP版
- 传奇世界客户端下载器,史上最全传世客户端
- 传世GS20220920商业引擎注册+登录配置器 解压密码是1
- U2官方排行榜游戏网关 支持元神,支持传家宝
- GS开战传世客户端+服务端
- (淡漠夕阳)u2引擎合区工具
- 传世GS引擎消除“你的游戏客户端版本号过旧,请及时更新”提示
- 传世一机多区双线路配置器--免密码版本
- 传世凤凰登陆器劫持修复软件
- SQLite3 for Navicat
- 传奇世界npc对话框编辑工具
- 传世GS落霞铭文服务器端
- gs_20210409引擎包+注册机(无限制)
- 传奇世界NPC对话封包查看器[支持时长版和极速版]
- 彩虹引擎传世脚本编辑工具1.7版来了,支持函数脚本翻译
评论